//+------------------------------------------------------------------+
//| CTrader_Add 
//  BluePearl @ forex-tsd.com                 
//+------------------------------------------------------------------+

#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| external variables                                               |
//+------------------------------------------------------------------+
/*
1. CTrader_Add.mq4 will open automatically all 13 positions when placed on a chart 
   with the chosen lot size. make sure to give the core position a different magic number than 
   the added positions. give the added positions all the same magic number. after all positions 
   are opened, remove EA from chart.
2. CTrader_Close.mq4 will close all of the positions with a given magic number. input the magic 
   number of the added positions and the core positions will not be touched. 
   after all added positions have been closed, remove EA from chart.
*/
extern string ________Close_Orders________ = "";                    
extern bool       CloseAllTrades       = false;
extern bool       CloseBasket_1        = false;
extern bool       CloseBasket_2        = false;
extern bool       CloseBasket_3        = false;
extern bool       CloseBasket_4        = false;
extern string _Close_Automatic_With_Profit_ = "";                    
extern bool       CloseAllTradesWithProfit        = true;
extern int        All_Baskets_Profit_Pips         = 100;
extern bool       CloseBasket_1_WithProfit        = false;
extern int        Baskets_1_Profit_Pips         = 100;
extern bool       CloseBasket_2_WithProfit        = false;
extern int        Baskets_2_Profit_Pips         = 100;
extern bool       CloseBasket_3_WithProfit        = false;
extern int        Baskets_3_Profit_Pips         = 100;
extern bool       CloseBasket_4_WithProfit        = false;
extern int        Baskets_4_Profit_Pips         = 100;

extern string ________Long_Symbols________ = "";                    
extern string     Symbol1Long          = "EURJPYm";
extern string     Symbol2Long          = "AUDJPYm";
extern string     Symbol3Long          = "USDCHFm";
extern string     Symbol4Long          = "NZDUSDm";
extern string     Symbol5Long          = "USDCADm";
extern string     Symbol6Long          = "EURCHFm";
extern string     Symbol7Long          = "GBPCHFm";
extern string     Symbol8Long          = "GBPUSDm";
extern string ________Short_Symbols________ = ""; 
extern string     Symbol1Short          = "EURUSDm";
extern string     Symbol2Short          = "EURGBPm";
extern string     Symbol3Short          = "EURAUDm";
extern string     Symbol4Short          = "CHFJPYm";
extern string     Symbol5Short          = "AUDUSDm";

extern string _____________Lots_____________ = ""; 
extern double     LotsA             = 0.02;   
extern double     LotsB             = 0.04; 
extern double     LotsC             = 0.08;     
extern double     LotsD             = 0.16;            

extern string _________Magic_Number_________ = "";
extern int        MagicA            = 10001;
extern int        MagicB            = 10002;
extern int        MagicC            = 10003;
extern int        MagicD            = 10004;
extern string _____Basket_Max_Lose_Pips_____ = "";
extern int        PipsA            = -1000;
extern int        PipsB            = -2000;
extern int        PipsC            = -3000;


//+------------------------------------------------------------------+
//| internal variables                                               |
//+------------------------------------------------------------------+
string s1="";
string s2="";
string s3="";
string s4="";
//+------------------------------------------------------------------+
//| expert initialization                                            |
//+------------------------------------------------------------------+

int init()
  { 
      
   return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization and start                                |
//+------------------------------------------------------------------+

int deinit()
  {
   return(0);
  }

string basket_profit(int MagicA, double  LotsA, int PipsA)
{
     double tprofit0;
     int tpips0=nr_pips(MagicA,tprofit0);
 
     string s1="MagicNo:"+MagicA+"  Lots:"+DoubleToStr(NormalizeDouble(LotsA,2),2)+"  Max Basket Profit:"+PipsA;    
     s1=s1 + "\n--------------------------------------------------------------";     
     s1=s1 + "\nBasket Profit: "+DoubleToStr(tpips0,0)+" pips   "+DoubleToStr(tprofit0,2)+" USD";
     s1=s1 + "\n--------------------------------------------------------------";          
	  //Comment("");           
	  //Comment(s1);
  return(s1);
}
int start()   
{ 
  bool pl1=false,pl2=false,pl3=false;

  double tprofitA;
  double tprofitB;
  double tprofitC;
  double tprofitD;
  int tpipsA=nr_pips(MagicA,tprofitA);
  int tpipsB=nr_pips(MagicB,tprofitB);
  int tpipsC=nr_pips(MagicC,tprofitC);
  int tpipsD=nr_pips(MagicD,tprofitD);      
  int tpips0=tpipsA+tpipsB+tpipsC+tpipsD;  
   

   
   
   if(CloseAllTrades)
   { Print("CloseAllTrades");
     start_close(MagicA);   
     start_close(MagicB);
     start_close(MagicC);      
     start_close(MagicD);
   }
   else if(CloseBasket_1)
   { Print("CloseBasket_1");
     start_close(MagicA);   
   }  
   else if(CloseBasket_2)
   {Print("CloseBasket_2");
     start_close(MagicB);   
   }  
   else if(CloseBasket_3)
   { Print("CloseBasket_3");
     start_close(MagicC);  
   }  
   else if(CloseBasket_4)
   { Print("CloseBasket_4");
     start_close(MagicD);  
   }  
   else if (CloseAllTradesWithProfit && (tpips0 >= All_Baskets_Profit_Pips))
   { Print("CloseAllTradesWithProfit && (tpips0 >= All_Baskets_Profit_Pips)");
     start_close(MagicA);   
     start_close(MagicB);
     start_close(MagicC);      
     start_close(MagicD);
   }
   else if(CloseBasket_1_WithProfit && (tpipsA >= Baskets_1_Profit_Pips) )
   { Print("CloseBasket_1_WithProfit && (tpipsA >= Baskets_1_Profit_Pips)");
     start_close(MagicA);   
   }  
   else if(CloseBasket_2_WithProfit && (tpipsB >= Baskets_2_Profit_Pips) )
   { Print("CloseBasket_1_WithProfit && (tpipsA >= Baskets_1_Profit_Pips)");
     start_close(MagicB);   
   }  
   else if(CloseBasket_3_WithProfit && (tpipsC >= Baskets_3_Profit_Pips) )
   { Print("CloseBasket_3_WithProfit && (tpipsC >= Baskets_3_Profit_Pips)");
     start_close(MagicC);  
   }  
   else if(CloseBasket_4_WithProfit && (tpipsD >= Baskets_4_Profit_Pips) )
   { Print("CloseBasket_4_WithProfit && (tpipsD >= Baskets_4_Profit_Pips)");
     start_close(MagicD);  
   }
   else
   { Print("start_open(MagicA,LotsA)");
     start_open(MagicA,LotsA);
     pl1=cond(MagicA,MagicB,PipsA);
     if(pl1)
     { Print("start_open(MagicB,LotsB)");
       start_open(MagicB,LotsB);
     }  
     pl2=cond(MagicB,MagicC,PipsB);  
     if(pl2)
     { Print("start_open(MagicC,LotsC)");
       start_open(MagicC,LotsC);   
     }  
     pl3=cond(MagicC,MagicD,PipsC);  
     if(pl3)
     { Print("start_open(MagicD,LotsD)");
       start_open(MagicD,LotsD);                 
     }  
   }   
   s1=basket_profit(MagicA,LotsA,PipsA);
   s2=basket_profit(MagicB,LotsB,PipsB);
   s3=basket_profit(MagicC,LotsC,PipsC);
   s4=basket_profit(MagicD,LotsD,-100000);     
   Comment("");  
   Comment("\n"+s1+"\n"+s2+"\n"+s3+"\n"+s4);
      
    
  
}

int nr_pips(int MagicA, double &tprofit0)
{

  int tpips0,tpips1,tpips2,tpips3,tpips4,tpips5,tpips6,tpips7,tpips8,tpips9,tpips10,tpips11,tpips12,tpips13;
  double tprofit1,tprofit2,tprofit3,tprofit4,tprofit5,tprofit6,tprofit7,tprofit8,tprofit9,tprofit10,tprofit11,tprofit12,tprofit13;
     //Long
     TotalProfit(MagicA, Symbol1Long, tpips1, tprofit1);
     TotalProfit(MagicA, Symbol2Long, tpips2, tprofit2);
     TotalProfit(MagicA, Symbol3Long, tpips3, tprofit3);
     TotalProfit(MagicA, Symbol4Long, tpips4, tprofit4);
     TotalProfit(MagicA, Symbol5Long, tpips5, tprofit5);
     TotalProfit(MagicA, Symbol6Long, tpips6, tprofit6);
     TotalProfit(MagicA, Symbol7Long, tpips7, tprofit7);
     TotalProfit(MagicA, Symbol8Long, tpips8, tprofit8);
     //Short     
     TotalProfit(MagicA, Symbol1Short, tpips9, tprofit9);
     TotalProfit(MagicA, Symbol2Short, tpips10, tprofit10);
     TotalProfit(MagicA, Symbol3Short, tpips11, tprofit11);
     TotalProfit(MagicA, Symbol4Short, tpips12, tprofit12);
     TotalProfit(MagicA, Symbol5Short, tpips13, tprofit13);

     tpips0=tpips1+tpips2+tpips3+tpips4+tpips5+tpips6+tpips7+tpips8+tpips9+tpips10+tpips11+tpips12+tpips13;
     tprofit0=tprofit1+tprofit2+tprofit3+tprofit4+tprofit5+tprofit6+tprofit7+tprofit8+tprofit9+tprofit10+tprofit11+tprofit12+tprofit13;     
return (tpips0);
}

int nr_ord(int MagicA)
{
     int Order=0,Order1=0,Order2=0,Order3=0,Order4=0,Order5=0,Order6=0,Order7=0,Order8=0,Order9=0,Order10=0,Order11=0,Order12=0,Order13=0 ;

     Order1=OrdersTotal1(MagicA, Symbol1Long);
	  Order2=OrdersTotal1(MagicA, Symbol2Long);
	  Order3=OrdersTotal1(MagicA, Symbol3Long);
	  Order4=OrdersTotal1(MagicA, Symbol4Long);
	  Order5=OrdersTotal1(MagicA, Symbol5Long);
	  Order6=OrdersTotal1(MagicA, Symbol6Long);
	  Order7=OrdersTotal1(MagicA, Symbol7Long);
	  Order8=OrdersTotal1(MagicA, Symbol8Long);
	  Order9=OrdersTotal1(MagicA, Symbol1Short);
	  Order10=OrdersTotal1(MagicA, Symbol2Short);
	  Order11=OrdersTotal1(MagicA, Symbol3Short);
	  Order12=OrdersTotal1(MagicA, Symbol4Short);
	  Order13=OrdersTotal1(MagicA, Symbol5Short);
	  
	  Order=Order1+Order2+Order3+Order4+Order5+Order6+Order7+Order8+Order9+Order10+Order11+Order12+Order13;
  return(Order);
}

int start_close(int MagicA)
{

int gi_148 = 0;   
	 
while (nr_ord(MagicA) > 0 ) 
{
  gi_148++;
  
  int total = OrdersTotal();
  for(int i=total-1;i>=0;i--)
  {
    OrderSelect(i, SELECT_BY_POS);
    
    if (OrderMagicNumber() == MagicA) {
    int type   = OrderType();

    bool result = false;
    
    switch(type)
    {
      //Close opened long positions
      case OP_BUY       : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_BID), 5, Red );
                          break;
      
      //Close opened short positions
      case OP_SELL      : result = OrderClose( OrderTicket(), OrderLots(), MarketInfo(OrderSymbol(), MODE_ASK), 5, Red );
                          break;
    }
    
    }
    
    //if(result == false)
    //{
    //  Alert("Order " , OrderTicket() , " failed to close. Error:" ,   GetLastError() );
    //  Sleep(3000);
   // }  
  }
  Sleep(10000);
  RefreshRates();
}  
  return(result);
}

bool cond(int MagicA,int MagicB,int MaxPips)
{
     double tprofit0;
     int tpips0=nr_pips(MagicA,tprofit0);
     int OrderA=nr_ord(MagicA);
	  int OrderB=nr_ord(MagicB);
	  bool r1=false;
	  if((OrderB==0) && (tpips0<MaxPips)) 
	    r1=true;
	  if((OrderB > 0) && (OrderB < 13))
	    r1=true;  
     return(r1);
}
  
int start_open(int MagicA,double LotsA)   
{  
  string ss1;             
  string comment;
  int Order1=0,Order2=0,Order3=0,Order4=0,Order5=0,Order6=0,Order7=0,Order8=0,Order9=0,Order10=0,Order11=0,Order12=0,Order13=0 ;
  
  
  ss1=DoubleToStr(MagicA,0);             
  comment = "CTrader "+ss1;

//+------------------------------------------------------------------+
//| ea stop                                                     |
//+------------------------------------------------------------------+

   if (!IsTradeAllowed())
   {
      //Comment("                      WARNING - TRADE IS NOT ALLOWED !");
      //return(0);
   }
                 
//+------------------------------------------------------------------+
//| place trades                                                     |
//+------------------------------------------------------------------+

      double tprofit0;
     int tpips0=nr_pips(MagicA,tprofit0);
 
     //s1="MagicNo:"+MagicA+"\n";    
     //s1=s1 + "--------------------------------------------------------------";     
     //s1=s1 + "\nBasket Profit: "+DoubleToStr(tpips0,0)+" pips   "+DoubleToStr(tprofit0,2)+" USD";
     //s1=s1 + "\n--------------------------------------------------------------";          
	  //Comment("");           
	  //Comment(s1);

	       
     //TimeHour(CurTime()) == 23 && TimeMinute(CurTime()) == 15 //GMT+2 MIGFX                    
     Order1=OrdersTotal1(MagicA, Symbol1Long);
	  if (IsTradeAllowed() && Order1==0) 
	  {
      OrderSend(Symbol1Long,OP_BUY,LotsA,MarketInfo(Symbol1Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);      
	  }  
	  Order2=OrdersTotal1(MagicA, Symbol2Long);
	  if (IsTradeAllowed() && Order2==0) 
	  {
      OrderSend(Symbol2Long,OP_BUY,LotsA,MarketInfo(Symbol2Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);
	  }
	  Order3=OrdersTotal1(MagicA, Symbol3Long);
	  if (IsTradeAllowed() && Order3==0) 
	  {
      OrderSend(Symbol3Long,OP_BUY,LotsA,MarketInfo(Symbol3Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);
	  }	  
	  Order4=OrdersTotal1(MagicA, Symbol4Long);
	  if (IsTradeAllowed() && Order4==0) 
	  {
      OrderSend(Symbol4Long,OP_BUY,LotsA,MarketInfo(Symbol4Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);
	  }	  
	  Order5=OrdersTotal1(MagicA, Symbol5Long);
	  if (IsTradeAllowed() && Order5==0) 
	  {
      OrderSend(Symbol5Long,OP_BUY,LotsA,MarketInfo(Symbol5Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);
	  }	  
	  Order6=OrdersTotal1(MagicA, Symbol6Long);
	  if (IsTradeAllowed() && Order6==0) 
	  {
      OrderSend(Symbol6Long,OP_BUY,LotsA,MarketInfo(Symbol6Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);
     }	  
	  Order7=OrdersTotal1(MagicA, Symbol7Long);
	  if (IsTradeAllowed() && Order7==0) 
	  {
      OrderSend(Symbol7Long,OP_BUY,LotsA,MarketInfo(Symbol7Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);
	  }	
	  Order8=OrdersTotal1(MagicA, Symbol8Long);
	  if (IsTradeAllowed() && Order8==0) 
	  {
      OrderSend(Symbol8Long,OP_BUY,LotsA,MarketInfo(Symbol8Long,MODE_ASK),3,0,0,comment,MagicA,0,Blue);
	  }
	  Order9=OrdersTotal1(MagicA, Symbol1Short);
	  if (IsTradeAllowed() && Order9==0) 
	  {
	  OrderSend(Symbol1Short,OP_SELL,LotsA,MarketInfo(Symbol1Short,MODE_BID),3,0,0,comment,MagicA,0,Red);
	  }
	  Order10=OrdersTotal1(MagicA, Symbol2Short);
	  if (IsTradeAllowed() && Order10==0) 
	  {
	  OrderSend(Symbol2Short,OP_SELL,LotsA,MarketInfo(Symbol2Short,MODE_BID),3,0,0,comment,MagicA,0,Red);
	  }
	  Order11=OrdersTotal1(MagicA, Symbol3Short);
	  if (IsTradeAllowed() && Order11==0) 
	  {
	  OrderSend(Symbol3Short,OP_SELL,LotsA,MarketInfo(Symbol3Short,MODE_BID),3,0,0,comment,MagicA,0,Red);
     }
	  Order12=OrdersTotal1(MagicA, Symbol4Short);
	  if (IsTradeAllowed() && Order12==0) 
	  {
	  OrderSend(Symbol4Short,OP_SELL,LotsA,MarketInfo(Symbol4Short,MODE_BID),3,0,0,comment,MagicA,0,Red);      
	  }
	  Order13=OrdersTotal1(MagicA, Symbol5Short);
	  if (IsTradeAllowed() && Order13==0) 
	  {
	  OrderSend(Symbol5Short,OP_SELL,LotsA,MarketInfo(Symbol5Short,MODE_BID),3,0,0,comment,MagicA,0,Red);
	  }
	   

 return(tpips0);
}



//+--------- --------- --------- --------- --------- --------- ----+
//+ 
//+--------- --------- --------- --------- --------- --------- ----+
int OrdersTotal1(int Magic1, string symb1) {
  int l_count_4 = 0;
  int l_pos_0 = OrdersTotal();
  if (l_pos_0 == 0) return (0);
  else 
  {
    while (l_pos_0 >= 0) 
    {
      RefreshRates();
      OrderSelect(l_pos_0, SELECT_BY_POS);
      if ( (Magic1>0) && (OrderMagicNumber() == Magic1) && (OrderSymbol() == symb1) ) l_count_4++;
      l_pos_0--;
    }
  }
  return (l_count_4);
}

//+--------- --------- --------- --------- --------- --------- ----+
//+ 
//+--------- --------- --------- --------- --------- --------- ----+
void TotalProfit(int Magic1, string symb1,int &totalPips,double &totalProfits)
{
   int total=OrdersTotal();
   totalPips = 0;
   totalProfits = 0;
   for (int cnt=0;cnt<total;cnt++)
   { 
   OrderSelect(cnt, SELECT_BY_POS);   
   int mode=OrderType();
   bool condition = false;
   if ( (Magic1>0) && (OrderMagicNumber()==Magic1) && (OrderSymbol() == symb1) ) condition = true;
   else if ( Magic1==0 ) condition = true;   
      if (condition)
      {               
         switch (mode)
         {
         case OP_BUY:
            totalPips += MathRound((MarketInfo(OrderSymbol(),MODE_BID)-OrderOpenPrice())/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((Bid-OrderOpenPrice())/Point);
            totalProfits += OrderProfit();
            break;
            
         case OP_SELL:
            totalPips += MathRound((OrderOpenPrice()-MarketInfo(OrderSymbol(),MODE_ASK))/MarketInfo(OrderSymbol(),MODE_POINT));
            //totalPips += MathRound((OrderOpenPrice()-Ask)/Point);
            totalProfits += OrderProfit();
            break;
         }
      }            
	}
}



